OpenTTD Source: src/toolbar_gui.cpp File Reference

OpenTTD Source 12.2

Data Structures | Typedefs | Enumerations | Functions | Variables
toolbar_gui.cpp File Reference
`#include "stdafx.h"`
`#include "gui.h"`
`#include "window_gui.h"`
`#include "window_func.h"`
`#include "viewport_func.h"`
`#include "command_func.h"`
`#include "vehicle_gui.h"`
`#include "rail_gui.h"`
`#include "road.h"`
`#include "road_gui.h"`
`#include "date_func.h"`
`#include "vehicle_func.h"`
`#include "sound_func.h"`
`#include "terraform_gui.h"`
`#include "strings_func.h"`
`#include "company_func.h"`
`#include "company_gui.h"`
`#include "vehicle_base.h"`
`#include "cheat_func.h"`
`#include "transparency_gui.h"`
`#include "screenshot.h"`
`#include "signs_func.h"`
`#include "fios.h"`
`#include "console_gui.h"`
`#include "news_gui.h"`
`#include "ai/ai_gui.hpp"`
`#include "tilehighlight_func.h"`
`#include "smallmap_gui.h"`
`#include "graph_gui.h"`
`#include "textbuf_gui.h"`
`#include "linkgraph/linkgraph_gui.h"`
`#include "newgrf_debug.h"`
`#include "hotkeys.h"`
`#include "engine_base.h"`
`#include "highscore.h"`
`#include "game/game.hpp"`
`#include "goal_base.h"`
`#include "story_base.h"`
`#include "toolbar_gui.h"`
`#include "framerate_type.h"`
`#include "guitimer_func.h"`
`#include "screenshot_gui.h"`
`#include "widgets/toolbar_widget.h"`
`#include "network/network.h"`
`#include "network/network_gui.h"`
`#include "network/network_func.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
class | DropDownListCheckedItem
| Drop down list entry for showing a checked/unchecked toggle item. More...
class | DropDownListCompanyItem
| Drop down list entry for showing a company entry, with companies 'blob'. More...
class | NWidgetToolbarContainer
| Full blown container to make it behave exactly as we want :) More...
class | NWidgetMainToolbarContainer
| Container for the 'normal' main toolbar. More...
class | NWidgetScenarioToolbarContainer
| Container for the scenario editor's toolbar. More...
struct | MainToolbarWindow
| Main toolbar. More...
struct | ScenarioEditorToolbarWindow

## Typedefs
typedef CallBackFunction | MenuClickedProc(int index)
typedef CallBackFunction | ToolbarButtonProc(Window *w)

## Enumerations
enum | ToolbarMode { TB_NORMAL, TB_UPPER, TB_LOWER }
| Toobar modes.
enum | CallBackFunction { CBF_NONE, CBF_PLACE_SIGN, CBF_PLACE_LANDINFO }
| Callback functions.
enum | OptionMenuEntries { OME_GAMEOPTIONS, OME_SETTINGS, OME_SCRIPT_SETTINGS, OME_NEWGRFSETTINGS, OME_TRANSPARENCIES, OME_SHOW_TOWNNAMES, OME_SHOW_STATIONNAMES, OME_SHOW_WAYPOINTNAMES, OME_SHOW_SIGNS, OME_SHOW_COMPETITOR_SIGNS, OME_FULL_ANIMATION, OME_FULL_DETAILS, OME_TRANSPARENTBUILDINGS, OME_SHOW_STATIONSIGNS }
| Game Option button menu entries.
enum | SaveLoadEditorMenuEntries { SLEME_SAVE_SCENARIO = 0, SLEME_LOAD_SCENARIO, SLEME_SAVE_HEIGHTMAP, SLEME_LOAD_HEIGHTMAP, SLEME_EXIT_TOINTRO, SLEME_EXIT_GAME = 6, SLEME_MENUCOUNT }
| SaveLoad entries in scenario editor mode.
enum | SaveLoadNormalMenuEntries { SLNME_SAVE_GAME = 0, SLNME_LOAD_GAME, SLNME_EXIT_TOINTRO, SLNME_EXIT_GAME = 4, SLNME_MENUCOUNT }
| SaveLoad entries in normal game mode.
enum | MapMenuEntries { MME_SHOW_SMALLMAP = 0, MME_SHOW_EXTRAVIEWPORTS, MME_SHOW_LINKGRAPH, MME_SHOW_SIGNLISTS, MME_SHOW_TOWNDIRECTORY, MME_SHOW_INDUSTRYDIRECTORY }
enum | MainToolbarEditorHotkeys { MTEHK_PAUSE, MTEHK_FASTFORWARD, MTEHK_SETTINGS, MTEHK_SAVEGAME, MTEHK_GENLAND, MTEHK_GENTOWN, MTEHK_GENINDUSTRY, MTEHK_BUILD_ROAD, MTEHK_BUILD_TRAM, MTEHK_BUILD_DOCKS, MTEHK_BUILD_TREES, MTEHK_SIGN, MTEHK_MUSIC, MTEHK_LANDINFO, MTEHK_SMALL_SCREENSHOT, MTEHK_ZOOMEDIN_SCREENSHOT, MTEHK_DEFAULTZOOM_SCREENSHOT, MTEHK_GIANT_SCREENSHOT, MTEHK_ZOOM_IN, MTEHK_ZOOM_OUT, MTEHK_TERRAFORM, MTEHK_SMALLMAP, MTEHK_EXTRA_VIEWPORT }

## Functions
static void | PopupMainToolbMenu (Window *w, int widget, DropDownList &&list, int def)
| Pop up a generic text only menu. More...
static void | PopupMainToolbMenu (Window *w, int widget, StringID string, int count)
| Pop up a generic text only menu. More...
static void | PopupMainCompanyToolbMenu (Window *w, int widget, int grey=0)
| Pop up a generic company list menu. More...
static CallBackFunction | SelectSignTool ()
static CallBackFunction | ToolbarPauseClick (Window *w)
static CallBackFunction | ToolbarFastForwardClick (Window *w)
| Toggle fast forward mode. More...
static CallBackFunction | ToolbarOptionsClick (Window *w)
| Handle click on Options button in toolbar. More...
static CallBackFunction | MenuClickSettings (int index)
| Handle click on one of the entries in the Options button menu. More...
static CallBackFunction | ToolbarSaveClick (Window *w)
| Handle click on Save button in toolbar in normal game mode. More...
static CallBackFunction | ToolbarScenSaveOrLoad (Window *w)
| Handle click on SaveLoad button in toolbar in the scenario editor. More...
static CallBackFunction | MenuClickSaveLoad (int index=0)
| Handle click on one of the entries in the SaveLoad menu. More...
static CallBackFunction | ToolbarMapClick (Window *w)
static CallBackFunction | ToolbarScenMapTownDir (Window *w)
static CallBackFunction | MenuClickMap (int index)
| Handle click on one of the entries in the Map menu. More...
static CallBackFunction | ToolbarTownClick (Window *w)
static CallBackFunction | MenuClickTown (int index)
| Handle click on one of the entries in the Town menu. More...
static CallBackFunction | ToolbarSubsidiesClick (Window *w)
static CallBackFunction | MenuClickSubsidies (int index)
| Handle click on the entry in the Subsidies menu. More...
static CallBackFunction | ToolbarStationsClick (Window *w)
static CallBackFunction | MenuClickStations (int index)
| Handle click on the entry in the Stations menu. More...
static CallBackFunction | ToolbarFinancesClick (Window *w)
static CallBackFunction | MenuClickFinances (int index)
| Handle click on the entry in the finances overview menu. More...
static CallBackFunction | ToolbarCompaniesClick (Window *w)
static CallBackFunction | MenuClickCompany (int index)
| Handle click on the entry in the Company menu. More...
static CallBackFunction | ToolbarStoryClick (Window *w)
static CallBackFunction | MenuClickStory (int index)
| Handle click on the entry in the Story menu. More...
static CallBackFunction | ToolbarGoalClick (Window *w)
static CallBackFunction | MenuClickGoal (int index)
| Handle click on the entry in the Goal menu. More...
static CallBackFunction | ToolbarGraphsClick (Window *w)
static CallBackFunction | MenuClickGraphs (int index)
| Handle click on the entry in the Graphs menu. More...
static CallBackFunction | ToolbarLeagueClick (Window *w)
static CallBackFunction | MenuClickLeague (int index)
| Handle click on the entry in the CompanyLeague menu. More...
static CallBackFunction | ToolbarIndustryClick (Window *w)
static CallBackFunction | MenuClickIndustry (int index)
| Handle click on the entry in the Industry menu. More...
static void | ToolbarVehicleClick (Window *w, VehicleType veh)
static CallBackFunction | ToolbarTrainClick (Window *w)
static CallBackFunction | MenuClickShowTrains (int index)
| Handle click on the entry in the Train menu. More...
static CallBackFunction | ToolbarRoadClick (Window *w)
static CallBackFunction | MenuClickShowRoad (int index)
| Handle click on the entry in the Road Vehicles menu. More...
static CallBackFunction | ToolbarShipClick (Window *w)
static CallBackFunction | MenuClickShowShips (int index)
| Handle click on the entry in the Ships menu. More...
static CallBackFunction | ToolbarAirClick (Window *w)
static CallBackFunction | MenuClickShowAir (int index)
| Handle click on the entry in the Aircraft menu. More...
static CallBackFunction | ToolbarZoomInClick (Window *w)
static CallBackFunction | ToolbarZoomOutClick (Window *w)
static CallBackFunction | ToolbarBuildRailClick (Window *w)
static CallBackFunction | MenuClickBuildRail (int index)
| Handle click on the entry in the Build Rail menu. More...
static CallBackFunction | ToolbarBuildRoadClick (Window *w)
static CallBackFunction | MenuClickBuildRoad (int index)
| Handle click on the entry in the Build Road menu. More...
static CallBackFunction | ToolbarBuildTramClick (Window *w)
static CallBackFunction | MenuClickBuildTram (int index)
| Handle click on the entry in the Build Tram menu. More...
static CallBackFunction | ToolbarBuildWaterClick (Window *w)
static CallBackFunction | MenuClickBuildWater (int index)
| Handle click on the entry in the Build Waterways menu. More...
static CallBackFunction | ToolbarBuildAirClick (Window *w)
static CallBackFunction | MenuClickBuildAir (int index)
| Handle click on the entry in the Build Air menu. More...
static CallBackFunction | ToolbarForestClick (Window *w)
static CallBackFunction | MenuClickForest (int index)
| Handle click on the entry in the landscaping menu. More...
static CallBackFunction | ToolbarMusicClick (Window *w)
static CallBackFunction | MenuClickMusicWindow (int index)
| Handle click on the entry in the Music menu. More...
static CallBackFunction | ToolbarNewspaperClick (Window *w)
static CallBackFunction | MenuClickNewspaper (int index)
| Handle click on the entry in the Newspaper menu. More...
static CallBackFunction | PlaceLandBlockInfo ()
static CallBackFunction | ToolbarHelpClick (Window *w)
void | ToggleBoundingBoxes ()
| Toggle drawing of sprites' bounding boxes. More...
void | ToggleDirtyBlocks ()
| Toggle drawing of the dirty blocks. More...
void | SetStartingYear (Year year)
| Set the starting year for a scenario. More...
static CallBackFunction | MenuClickHelp (int index)
| Choose the proper callback function for the main toolbar's help menu. More...
static CallBackFunction | ToolbarSwitchClick (Window *w)
static CallBackFunction | ToolbarScenDatePanel (Window *w)
| Called when clicking at the date panel of the scenario editor toolbar.
static CallBackFunction | ToolbarScenDateBackward (Window *w)
static CallBackFunction | ToolbarScenDateForward (Window *w)
static CallBackFunction | ToolbarScenGenLand (Window *w)
static CallBackFunction | ToolbarScenGenTown (Window *w)
static CallBackFunction | ToolbarScenGenIndustry (Window *w)
static CallBackFunction | ToolbarScenBuildRoadClick (Window *w)
static CallBackFunction | ToolbarScenBuildRoad (int index)
| Handle click on the entry in the Build Road menu. More...
static CallBackFunction | ToolbarScenBuildTramClick (Window *w)
static CallBackFunction | ToolbarScenBuildTram (int index)
| Handle click on the entry in the Build Tram menu. More...
static CallBackFunction | ToolbarScenBuildDocks (Window *w)
static CallBackFunction | ToolbarScenPlantTrees (Window *w)
static CallBackFunction | ToolbarScenPlaceSign (Window *w)
static CallBackFunction | ToolbarBtn_NULL (Window *w)
static NWidgetBase * | MakeMainToolbar (int *biggest_index)
static NWidgetBase * | MakeScenarioToolbar (int *biggest_index)
void | AllocateToolbar ()
| Allocate the toolbar.

## Variables
uint | _toolbar_width = 0
| Width of the toolbar, shared by statusbar.
RailType | _last_built_railtype
RoadType | _last_built_roadtype
RoadType | _last_built_tramtype
static CallBackFunction | _last_started_action = CBF_NONE
| Last started user action.
static const int | CTMN_CLIENT_LIST = -1
| Enum for the Company Toolbar's network related buttons. More...
static const int | CTMN_SPECTATE = -2
| Become spectator.
static const int | CTMN_SPECTATOR = -3
| Show a company window as spectator.
static ToolbarMode | _toolbar_mode
static MenuClickedProc *const | _menu_clicked_procs []
static ToolbarButtonProc *const | _toolbar_button_procs []
const uint16 | _maintoolbar_pause_keys [] = {WKC_F1, WKC_PAUSE, 0}
const uint16 | _maintoolbar_zoomin_keys [] = {WKC_NUM_PLUS, WKC_EQUALS, WKC_SHIFT | WKC_EQUALS, WKC_SHIFT | WKC_F5, 0}
const uint16 | _maintoolbar_zoomout_keys [] = {WKC_NUM_MINUS, WKC_MINUS, WKC_SHIFT | WKC_MINUS, WKC_SHIFT | WKC_F6, 0}
const uint16 | _maintoolbar_smallmap_keys [] = {WKC_F4, 'M', 0}
static Hotkey | maintoolbar_hotkeys []
static const NWidgetPart | _nested_toolbar_normal_widgets []
static WindowDesc | _toolb_normal_desc (WDP_MANUAL, nullptr, 0, 0, WC_MAIN_TOOLBAR, WC_NONE, WDF_NO_FOCUS, _nested_toolbar_normal_widgets, lengthof(_nested_toolbar_normal_widgets), &MainToolbarWindow::hotkeys)
static MenuClickedProc *const | _scen_toolbar_dropdown_procs []
static ToolbarButtonProc *const | _scen_toolbar_button_procs []
static Hotkey | scenedit_maintoolbar_hotkeys []
static const NWidgetPart | _nested_toolb_scen_inner_widgets []
static const NWidgetPart | _nested_toolb_scen_widgets []
static WindowDesc | _toolb_scen_desc (WDP_MANUAL, nullptr, 0, 0, WC_MAIN_TOOLBAR, WC_NONE, WDF_NO_FOCUS, _nested_toolb_scen_widgets, lengthof(_nested_toolb_scen_widgets), &ScenarioEditorToolbarWindow::hotkeys)

## Detailed Description

Code related to the (main) toolbar.

Definition in file toolbar_gui.cpp.

## Function Documentation

## ◆ MakeMainToolbar()

static NWidgetBase* MakeMainToolbar | ( | int * | biggest_index | ) |
| static

Sprites to use for the different toolbar buttons

Definition at line 2158 of file toolbar_gui.cpp.

## ◆ MenuClickBuildAir()

static CallBackFunction MenuClickBuildAir | ( | int | index | ) |
| static

Handle click on the entry in the Build Air menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 963 of file toolbar_gui.cpp.

References ShowBuildAirToolbar().

## ◆ MenuClickBuildRail()

static CallBackFunction MenuClickBuildRail | ( | int | index | ) |
| static

Handle click on the entry in the Build Rail menu.

Parameters

  index | RailType to show the build toolbar for.

Returns
  #CBF_NONE

Definition at line 872 of file toolbar_gui.cpp.

## ◆ MenuClickBuildRoad()

static CallBackFunction MenuClickBuildRoad | ( | int | index | ) |
| static

Handle click on the entry in the Build Road menu.

Parameters

  index | RoadType to show the build toolbar for.

Returns
  #CBF_NONE

Definition at line 894 of file toolbar_gui.cpp.

## ◆ MenuClickBuildTram()

static CallBackFunction MenuClickBuildTram | ( | int | index | ) |
| static

Handle click on the entry in the Build Tram menu.

Parameters

  index | RoadType to show the build toolbar for.

Returns
  #CBF_NONE

Definition at line 916 of file toolbar_gui.cpp.

## ◆ MenuClickBuildWater()

static CallBackFunction MenuClickBuildWater | ( | int | index | ) |
| static

Handle click on the entry in the Build Waterways menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 940 of file toolbar_gui.cpp.

References ShowBuildDocksToolbar().

## ◆ MenuClickCompany()

static CallBackFunction MenuClickCompany | ( | int | index | ) |
| static

Handle click on the entry in the Company menu.

Parameters

  index | Menu entry to handle.

Returns
  #CBF_NONE

Definition at line 603 of file toolbar_gui.cpp.

References _networking, and CTMN_CLIENT_LIST.

## ◆ MenuClickFinances()

static CallBackFunction MenuClickFinances | ( | int | index | ) |
| static

Handle click on the entry in the finances overview menu.

Parameters

  index | CompanyID to show finances for.

Returns
  #CBF_NONE

Definition at line 583 of file toolbar_gui.cpp.

References ShowCompanyFinances().

## ◆ MenuClickForest()

static CallBackFunction MenuClickForest | ( | int | index | ) |
| static

Handle click on the entry in the landscaping menu.

Parameters

  index | Menu entry clicked.

Returns
  #CBF_NONE

Definition at line 988 of file toolbar_gui.cpp.

References ShowTerraformToolbar().

## ◆ MenuClickGoal()

static CallBackFunction MenuClickGoal | ( | int | index | ) |
| static

Handle click on the entry in the Goal menu.

Parameters

  index | CompanyID to show story book for

Returns
  #CBF_NONE

Definition at line 659 of file toolbar_gui.cpp.

References CTMN_SPECTATOR, INVALID_COMPANY, and ShowGoalsList().

## ◆ MenuClickGraphs()

static CallBackFunction MenuClickGraphs | ( | int | index | ) |
| static

Handle click on the entry in the Graphs menu.

Parameters

  index | Graph to show.

Returns
  #CBF_NONE

Definition at line 679 of file toolbar_gui.cpp.

## ◆ MenuClickHelp()

static CallBackFunction MenuClickHelp | ( | int | index | ) |
| static

Choose the proper callback function for the main toolbar's help menu.

Parameters

  index | The menu index which was selected.

Returns
  CBF_NONE

Definition at line 1113 of file toolbar_gui.cpp.

## ◆ MenuClickIndustry()

static CallBackFunction MenuClickIndustry | ( | int | index | ) |
| static

Handle click on the entry in the Industry menu.

Parameters

  index | Menu entry number.

Returns
  #CBF_NONE

Definition at line 734 of file toolbar_gui.cpp.

## ◆ MenuClickLeague()

static CallBackFunction MenuClickLeague | ( | int | index | ) |
| static

Handle click on the entry in the CompanyLeague menu.

Parameters

  index | Menu entry number.

Returns
  #CBF_NONE

Definition at line 709 of file toolbar_gui.cpp.

## ◆ MenuClickMap()

static CallBackFunction MenuClickMap | ( | int | index | ) |
| static

Handle click on one of the entries in the Map menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 489 of file toolbar_gui.cpp.

## ◆ MenuClickMusicWindow()

static CallBackFunction MenuClickMusicWindow | ( | int | index | ) |
| static

Handle click on the entry in the Music menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 1012 of file toolbar_gui.cpp.

## ◆ MenuClickNewspaper()

static CallBackFunction MenuClickNewspaper | ( | int | index | ) |
| static

Handle click on the entry in the Newspaper menu.

Parameters

  index | Menu entry clicked.

Returns
  #CBF_NONE

Definition at line 1032 of file toolbar_gui.cpp.

References DeleteAllMessages(), ShowLastNewsMessage(), and ShowMessageHistory().

## ◆ MenuClickSaveLoad()

static CallBackFunction MenuClickSaveLoad | ( | int | index = `0` | ) |
| static

Handle click on one of the entries in the SaveLoad menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 427 of file toolbar_gui.cpp.

## ◆ MenuClickSettings()

static CallBackFunction MenuClickSettings | ( | int | index | ) |
| static

Handle click on one of the entries in the Options button menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 347 of file toolbar_gui.cpp.

## ◆ MenuClickShowAir()

static CallBackFunction MenuClickShowAir | ( | int | index | ) |
| static

Handle click on the entry in the Aircraft menu.

Parameters

  index | CompanyID to show aircraft list for.

Returns
  #CBF_NONE

Definition at line 829 of file toolbar_gui.cpp.

## ◆ MenuClickShowRoad()

static CallBackFunction MenuClickShowRoad | ( | int | index | ) |
| static

Handle click on the entry in the Road Vehicles menu.

Parameters

  index | CompanyID to show road vehicles list for.

Returns
  #CBF_NONE

Definition at line 789 of file toolbar_gui.cpp.

## ◆ MenuClickShowShips()

static CallBackFunction MenuClickShowShips | ( | int | index | ) |
| static

Handle click on the entry in the Ships menu.

Parameters

  index | CompanyID to show ship list for.

Returns
  #CBF_NONE

Definition at line 809 of file toolbar_gui.cpp.

## ◆ MenuClickShowTrains()

static CallBackFunction MenuClickShowTrains | ( | int | index | ) |
| static

Handle click on the entry in the Train menu.

Parameters

  index | CompanyID to show train list for.

Returns
  #CBF_NONE

Definition at line 769 of file toolbar_gui.cpp.

## ◆ MenuClickStations()

static CallBackFunction MenuClickStations | ( | int | index | ) |
| static

Handle click on the entry in the Stations menu.

Parameters

  index | CompanyID to show station list for

Returns
  #CBF_NONE

Definition at line 563 of file toolbar_gui.cpp.

References ShowCompanyStations().

## ◆ MenuClickStory()

static CallBackFunction MenuClickStory | ( | int | index | ) |
| static

Handle click on the entry in the Story menu.

Parameters

  index | CompanyID to show story book for

Returns
  #CBF_NONE

Definition at line 639 of file toolbar_gui.cpp.

References CTMN_SPECTATOR, INVALID_COMPANY, and ShowStoryBook().

## ◆ MenuClickSubsidies()

static CallBackFunction MenuClickSubsidies | ( | int | index | ) |
| static

Handle click on the entry in the Subsidies menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 541 of file toolbar_gui.cpp.

## ◆ MenuClickTown()

static CallBackFunction MenuClickTown | ( | int | index | ) |
| static

Handle click on one of the entries in the Town menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 516 of file toolbar_gui.cpp.

## ◆ PopupMainCompanyToolbMenu()

static void PopupMainCompanyToolbMenu | ( | Window * | w,
|  | int | widget,
|  | int | grey = `0`
| ) |  |
| static

Pop up a generic company list menu.

Parameters

  w | The toolbar window.
  widget | The button widget id.
  grey | A bitbask of which items to mark as disabled.

Definition at line 216 of file toolbar_gui.cpp.

References _local_company, _networking, COMPANY_FIRST, COMPANY_SPECTATOR, CTMN_CLIENT_LIST, CTMN_SPECTATE, CTMN_SPECTATOR, HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), MAX_COMPANIES, PopupMainToolbMenu(), WID_TN_COMPANIES, WID_TN_GOAL, and WID_TN_STORY.

## ◆ PopupMainToolbMenu() [1/2]

static void PopupMainToolbMenu | ( | Window * | w,
|  | int | widget,
|  | DropDownList && | list,
|  | int | def
| ) |  |
| static

Pop up a generic text only menu.

Parameters

  w | Toolbar
  widget | Toolbar button
  list | List of items
  def | Default item

Definition at line 183 of file toolbar_gui.cpp.

References _settings_client, SoundSettings::click_beep, ShowDropDownList(), and ClientSettings::sound.

Referenced by PopupMainCompanyToolbMenu(), PopupMainToolbMenu(), ToolbarSaveClick(), and ToolbarScenSaveOrLoad().

## ◆ PopupMainToolbMenu() [2/2]

static void PopupMainToolbMenu | ( | Window * | w,
|  | int | widget,
|  | StringID | string,
|  | int | count
| ) |  |
| static

Pop up a generic text only menu.

Parameters

  w | Toolbar
  widget | Toolbar button
  string | String for the first item in the menu
  count | Number of items in the menu

Definition at line 196 of file toolbar_gui.cpp.

References PopupMainToolbMenu().

## ◆ SetStartingYear()

void SetStartingYear | ( | Year | year | ) |

Set the starting year for a scenario.

Parameters

  year | New starting year.

Definition at line 1099 of file toolbar_gui.cpp.

References _date, _settings_game, Clamp(), ConvertYMDToDate(), GameSettings::game_creation, LinkGraphSchedule::instance, MAX_YEAR, MIN_YEAR, SetDate(), LinkGraphSchedule::ShiftDates(), and GameCreationSettings::starting_year.

Referenced by ScenarioEditorToolbarWindow::OnQueryTextFinished().

## ◆ ToggleBoundingBoxes()

void ToggleBoundingBoxes | ( |  | ) |

Toggle drawing of sprites' bounding boxes.

Note
  has only an effect when newgrf_developer_tools are active.

Function is found here and not in viewport.cpp in order to avoid importing the settings structs to there.

Definition at line 1068 of file toolbar_gui.cpp.

## ◆ ToggleDirtyBlocks()

void ToggleDirtyBlocks | ( |  | ) |

Toggle drawing of the dirty blocks.

Note
  has only an effect when newgrf_developer_tools are active.

Function is found here and not in viewport.cpp in order to avoid importing the settings structs to there.

Definition at line 1085 of file toolbar_gui.cpp.

## ◆ ToolbarFastForwardClick()

static CallBackFunction ToolbarFastForwardClick | ( | Window * | w | ) |
| static

Toggle fast forward mode.

Parameters

  w | Unused.

Returns
  #CBF_NONE

Definition at line 280 of file toolbar_gui.cpp.

## ◆ ToolbarOptionsClick()

static CallBackFunction ToolbarOptionsClick | ( | Window * | w | ) |
| static

Handle click on Options button in toolbar.

Parameters

  w | parent window the shown Drop down list is attached to.

Returns
  #CBF_NONE

Definition at line 314 of file toolbar_gui.cpp.

## ◆ ToolbarSaveClick()

static CallBackFunction ToolbarSaveClick | ( | Window * | w | ) |
| static

Handle click on Save button in toolbar in normal game mode.

Parameters

  w | parent window the shown save dialogue is attached to.

Returns
  #CBF_NONE

Definition at line 403 of file toolbar_gui.cpp.

References PopupMainToolbMenu(), and WID_TN_SAVE.

## ◆ ToolbarScenBuildRoad()

static CallBackFunction ToolbarScenBuildRoad | ( | int | index | ) |
| static

Handle click on the entry in the Build Road menu.

Parameters

  index | RoadType to show the build toolbar for.

Returns
  #CBF_NONE

Definition at line 1223 of file toolbar_gui.cpp.

## ◆ ToolbarScenBuildTram()

static CallBackFunction ToolbarScenBuildTram | ( | int | index | ) |
| static

Handle click on the entry in the Build Tram menu.

Parameters

  index | RoadType to show the build toolbar for.

Returns
  #CBF_NONE

Definition at line 1243 of file toolbar_gui.cpp.

## ◆ ToolbarScenSaveOrLoad()

static CallBackFunction ToolbarScenSaveOrLoad | ( | Window * | w | ) |
| static

Handle click on SaveLoad button in toolbar in the scenario editor.

Parameters

  w | parent window the shown save dialogue is attached to.

Returns
  #CBF_NONE

Definition at line 415 of file toolbar_gui.cpp.

References PopupMainToolbMenu(), and WID_TE_SAVE.

## Variable Documentation

## ◆ _nested_toolb_scen_widgets

const NWidgetPart _nested_toolb_scen_widgets[]
| static

Initial value:
= {
NWidgetFunction(MakeScenarioToolbar),
}

Definition at line 2564 of file toolbar_gui.cpp.

## ◆ _nested_toolbar_normal_widgets

const NWidgetPart _nested_toolbar_normal_widgets[]
| static

Initial value:
= {
NWidgetFunction(MakeMainToolbar),
}

Definition at line 2216 of file toolbar_gui.cpp.

## ◆ _scen_toolbar_button_procs

ToolbarButtonProc* const _scen_toolbar_button_procs[]
| static

Initial value:
= {
ToolbarPauseClick,
ToolbarFastForwardClick,
ToolbarOptionsClick,
ToolbarScenSaveOrLoad,
ToolbarBtn_NULL,
ToolbarScenDatePanel,
ToolbarScenDateBackward,
ToolbarScenDateForward,
ToolbarScenMapTownDir,
ToolbarZoomInClick,
ToolbarZoomOutClick,
ToolbarScenGenLand,
ToolbarScenGenTown,
ToolbarScenGenIndustry,
ToolbarScenBuildRoadClick,
ToolbarScenBuildTramClick,
ToolbarScenBuildDocks,
ToolbarScenPlantTrees,
ToolbarScenPlaceSign,
ToolbarBtn_NULL,
ToolbarMusicClick,
ToolbarHelpClick,
ToolbarSwitchClick,
}

Definition at line 2257 of file toolbar_gui.cpp.

## ◆ _scen_toolbar_dropdown_procs

MenuClickedProc* const _scen_toolbar_dropdown_procs[]
| static

Initial value:
= {
nullptr,
nullptr,
MenuClickSettings,
MenuClickSaveLoad,
nullptr,
nullptr,
nullptr,
nullptr,
MenuClickMap,
nullptr,
nullptr,
nullptr,
nullptr,
nullptr,
ToolbarScenBuildRoad,
ToolbarScenBuildTram,
nullptr,
nullptr,
nullptr,
nullptr,
MenuClickMusicWindow,
MenuClickHelp,
nullptr,
}

Definition at line 2231 of file toolbar_gui.cpp.

## ◆ CTMN_CLIENT_LIST

const int CTMN_CLIENT_LIST = -1
| static

Enum for the Company Toolbar's network related buttons.

Show the client list

Definition at line 206 of file toolbar_gui.cpp.

Referenced by MenuClickCompany(), and PopupMainCompanyToolbMenu().

## ◆ scenedit_maintoolbar_hotkeys

Hotkey scenedit_maintoolbar_hotkeys[]
| static

Initial value:
= {
Hotkey(_maintoolbar_pause_keys, "pause", MTEHK_PAUSE),
Hotkey((uint16)0, "fastforward", MTEHK_FASTFORWARD),
Hotkey(WKC_F2, "settings", MTEHK_SETTINGS),
Hotkey(WKC_F3, "saveload", MTEHK_SAVEGAME),
Hotkey(WKC_F4, "gen_land", MTEHK_GENLAND),
Hotkey(WKC_F5, "gen_town", MTEHK_GENTOWN),
Hotkey(WKC_F6, "gen_industry", MTEHK_GENINDUSTRY),
Hotkey(WKC_F7, "build_road", MTEHK_BUILD_ROAD),
Hotkey((uint16)0, "build_tram", MTEHK_BUILD_TRAM),
Hotkey(WKC_F8, "build_docks", MTEHK_BUILD_DOCKS),
Hotkey(WKC_F9, "build_trees", MTEHK_BUILD_TREES),
Hotkey(WKC_F10, "build_sign", MTEHK_SIGN),
Hotkey(WKC_F11, "music", MTEHK_MUSIC),
Hotkey(WKC_F12, "land_info", MTEHK_LANDINFO),
Hotkey(WKC_CTRL | 'S', "small_screenshot", MTEHK_SMALL_SCREENSHOT),
Hotkey(WKC_CTRL | 'P', "zoomedin_screenshot", MTEHK_ZOOMEDIN_SCREENSHOT),
Hotkey(WKC_CTRL | 'D', "defaultzoom_screenshot", MTEHK_DEFAULTZOOM_SCREENSHOT),
Hotkey((uint16)0, "giant_screenshot", MTEHK_GIANT_SCREENSHOT),
Hotkey(_maintoolbar_zoomin_keys, "zoomin", MTEHK_ZOOM_IN),
Hotkey(_maintoolbar_zoomout_keys, "zoomout", MTEHK_ZOOM_OUT),
Hotkey('L', "terraform", MTEHK_TERRAFORM),
Hotkey('M', "smallmap", MTEHK_SMALLMAP),
Hotkey('V', "extra_viewport", MTEHK_EXTRA_VIEWPORT),
HOTKEY_LIST_END
}

Definition at line 2496 of file toolbar_gui.cpp.

NWidgetFunction
static NWidgetPart NWidgetFunction(NWidgetFunctionType *func_ptr)
Obtain a nested widget (sub)tree from an external source.
Definition: widget_type.h:1239
ToolbarFastForwardClick
static CallBackFunction ToolbarFastForwardClick(Window *w)
Toggle fast forward mode.
Definition: toolbar_gui.cpp:280
ToolbarScenSaveOrLoad
static CallBackFunction ToolbarScenSaveOrLoad(Window *w)
Handle click on SaveLoad button in toolbar in the scenario editor.
Definition: toolbar_gui.cpp:415
MenuClickMap
static CallBackFunction MenuClickMap(int index)
Handle click on one of the entries in the Map menu.
Definition: toolbar_gui.cpp:489
ToolbarScenBuildTram
static CallBackFunction ToolbarScenBuildTram(int index)
Handle click on the entry in the Build Tram menu.
Definition: toolbar_gui.cpp:1243
ToolbarOptionsClick
static CallBackFunction ToolbarOptionsClick(Window *w)
Handle click on Options button in toolbar.
Definition: toolbar_gui.cpp:314
MenuClickSaveLoad
static CallBackFunction MenuClickSaveLoad(int index=0)
Handle click on one of the entries in the SaveLoad menu.
Definition: toolbar_gui.cpp:427
ToolbarScenDatePanel
static CallBackFunction ToolbarScenDatePanel(Window *w)
Called when clicking at the date panel of the scenario editor toolbar.
Definition: toolbar_gui.cpp:1150
ToolbarScenBuildRoad
static CallBackFunction ToolbarScenBuildRoad(int index)
Handle click on the entry in the Build Road menu.
Definition: toolbar_gui.cpp:1223
MakeMainToolbar
static NWidgetBase * MakeMainToolbar(int *biggest_index)
Definition: toolbar_gui.cpp:2158
MenuClickHelp
static CallBackFunction MenuClickHelp(int index)
Choose the proper callback function for the main toolbar's help menu.
Definition: toolbar_gui.cpp:1113
MenuClickSettings
static CallBackFunction MenuClickSettings(int index)
Handle click on one of the entries in the Options button menu.
Definition: toolbar_gui.cpp:347
MenuClickMusicWindow
static CallBackFunction MenuClickMusicWindow(int index)
Handle click on the entry in the Music menu.
Definition: toolbar_gui.cpp:1012
Hotkey
All data for a single hotkey.
Definition: hotkeys.h:22